## openio-gridinit 1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project (GridInit C)

include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckTypeSize)

set(GridInit_VERSION_MAJOR 1)
set(GridInit_VERSION_MINOR 1)
set(GridInit_RELEASE 5)
set(API_VERSION "${GridInit_VERSION_MAJOR}.${GridInit_VERSION_MINOR}.${GridInit_RELEASE}")
set(SHORT_API_VERSION "${GridInit_VERSION_MAJOR}.${GridInit_VERSION_MINOR}")
if (NOT ABI_VERSION)
	set(ABI_VERSION 0)
endif()

add_definitions(-DAPI_VERSION="${API_VERSION}")
add_definitions(-DSHORT_API_VERSION="${SHORT_API_VERSION}")

set(CMAKE_C_FLAGS "-g -Wall -Wextra -Wunused -pipe -std=gnu99")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

if (CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-variadic-macros")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsequence-point")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wredundant-decls")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")

	# gcc >= 4.2
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcomment")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmain")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wparentheses")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfloat-equal")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunsafe-loop-optimizations")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-parameter")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-variable")

	# gcc >= 4.6
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Winline")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wconversion")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wswitch-enum")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
MESSAGE("DEBUG symbols enabled")
endif()

set(CMAKE_C_FLAGS_DEBUG          "-O0 -fno-inline")
set(CMAKE_C_FLAGS_RELEASE        "-O2")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -fno-inline")
set(CMAKE_C_FLAGS_MINSIZEREL     "-Os")

add_definitions(-D_REENTRANT)
add_definitions(-D_LARGE_FILES)
add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_LARGEFILE64_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DG_ERRORCHECK_MUTEXES)
add_definitions(-DG_DISABLE_DEPRECATED=1)
add_definitions(-DHAVE_SOCKLEN_T)

if (NOT DEFINED GRIDINIT_SOCK_PATH)
	set(GRIDINIT_SOCK_PATH "/var/run/gridinit.sock")
endif()

add_definitions(-DGRIDINIT_SOCK_PATH="${GRIDINIT_SOCK_PATH}")
MESSAGE("GRIDINIT_SOCK_PATH ${GRIDINIT_SOCK_PATH}")

if (LD_LIBDIR)
	MESSAGE("LD_LIBDIR explicitely set to ${LD_LIBDIR}")
else()
	CHECK_TYPE_SIZE(long SIZEOF_LONG)
	message(STATUS "sizeof(long) = ${SIZEOF_LONG}")
	if(SIZEOF_LONG EQUAL 8)
		set (LD_LIBDIR "lib64")
	else()
		set (LD_LIBDIR "lib")
	endif()
	MESSAGE("LD_LIBDIR guessed to ${LD_LIBDIR}")
endif()


find_package(PkgConfig)
pkg_check_modules(GLIB2 REQUIRED glib-2.0 gthread-2.0 gmodule-2.0)
pkg_check_modules(LIBEVENT REQUIRED libevent)

### explicit plugin directory for alerting modules ###

set(GRIDINIT_PLUGINS_DIRECTORY "${LD_LIBDIR}/gridinit")
if(GRIDINIT_PLUGINS)
	set(GRIDINIT_PLUGINS_DIRECTORY "${GRIDINIT_PLUGINS}")
endif(GRIDINIT_PLUGINS)

set(CMAKE_LIBRARY_PATH "")
set(CMAKE_INCLUDE_PATH "")
include_directories(AFTER ${GLIB2_INCLUDE_DIRS})

add_subdirectory(./lib)
add_subdirectory(./main)

=== lib/CMakeLists.txt ===

include_directories(BEFORE .)

add_library(gridinit-utils SHARED
		uid.c
		common.c
		limits.c
		command.c
		children.c
		gridinit-utils.h
		gridinit-internals.h)

target_link_libraries(gridinit-utils
		${GLIB2_LIBRARIES})

set_target_properties(gridinit-utils PROPERTIES
		PUBLIC_HEADER "gridinit-utils.h"
		SOVERSION ${ABI_VERSION})

install(TARGETS gridinit-utils
		LIBRARY DESTINATION ${LD_LIBDIR}
		PUBLIC_HEADER DESTINATION include
		RUNTIME DESTINATION bin)

=== main/CMakeLists.txt ===

include_directories(BEFORE .
		../lib)

add_library(gridinit-internals STATIC
		utils.c
		cnx.c
		gridinit_internals.h)
target_link_libraries(gridinit-internals
		${GLIB2_LIBRARIES})

add_executable(gridinit
		gridinit.c
		alerting.c
		gridinit_alerts.h)
target_link_libraries(gridinit
		gridinit-utils gridinit-internals
		${GLIB2_LIBRARIES} ${LIBEVENT_LIBRARIES})

add_executable(gridinit_cmd
		gridinit_cmd.c)
target_link_libraries(gridinit_cmd
		gridinit-internals
		${GLIB2_LIBRARIES} ${LIBEVENT_LIBRARIES})

add_executable(gridinit_testcmd
		test_cmd.c)
target_link_libraries(gridinit_testcmd
		gridinit-utils gridinit-internals
		${GLIB2_LIBRARIES})

install(TARGETS gridinit gridinit_cmd
		LIBRARY DESTINATION ${LD_LIBDIR}
		PUBLIC_HEADER DESTINATION include
		RUNTIME DESTINATION bin)

=== debian/changelog ===
openio-gridinit (1.6-2) jessie; urgency=medium

  * Fix default socket path

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 04 Apr 2016 13:16:27 +0000

openio-gridinit (1.6-1) jessie; urgency=medium

  * New upstream release

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 31 Mar 2016 17:21:16 +0000

openio-gridinit (1.5-1) jessie; urgency=low

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 17 Oct 2015 10:03:08 +0000

openio-gridinit (1.4-3) jessie; urgency=low

  * Add tmpfile

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 08 Oct 2015 08:48:58 +0000

openio-gridinit (1.4-2) jessie; urgency=low

  * Add systemd file

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 08 Oct 2015 07:29:34 +0000

openio-gridinit (1.4-1) jessie; urgency=low

  * Initial release

 -- Romain Acciari <romain.acciari@openio.io>  Tue, 06 Oct 2015 15:05:35 +0000

=== debian/control ===
Source: openio-gridinit
Section: unknown
Priority: optional
Maintainer: Romain Acciari <romain.acciari@openio.io>
Build-Depends: debhelper (>= 9), dh-systemd, cmake, libevent-dev, libglib2.0-dev
Standards-Version: 3.9.5
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://anonscm.debian.org/collab-maint/openio-gridinit.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/openio-gridinit.git;a=summary

Package: openio-gridinit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenIO gridinit daemon
 Init program used by the  OpenIO Open Source Project. It forks processes
 and respawns them as soon as they die. It also provides a simple management
 interface through a UNIX socket. Services can be started/stopped/monitored.
 OpenIO gridinit is a fork of Redcurrant gridinit, from Worldline by Atos.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1
export DH_OPTIONS=-v

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ --with=systemd

override_dh_installinit:
	dh_installinit --name=gridinit

override_dh_auto_configure:
	dh_auto_configure -- \
	-DPREFIX=/usr \
	-DLD_LIBDIR=lib \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DGRIDINIT_SOCK_PATH="/run/gridinit/gridinit.sock"

override_dh_install:
	dh_install --sourcedir=debian/openio-gridinit 

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## openio-gridinit 1.7.0

=== debian/changelog ===
openio-gridinit (1.7.0-1) jessie; urgency=medium

  * Unreleased

 -- Vincent Legoll <vincent.legoll@openio.io>  Thu, 14 Jun 2018 11:31:27 +0000
